<template>
  <div style="margin-top: 20px">
    <v-container class="fill-height">
      <v-row align="center" justify="center">
        <v-col cols="12">
          <v-card>
            <v-toolbar flat>
              <v-toolbar-title>
                <v-icon color="info" class="mx-2">search</v-icon>ค้นหา
              </v-toolbar-title>
              <v-spacer></v-spacer>
            </v-toolbar>
            <v-card-text>
              <FilterLocation v-model="obj" :role="role" />
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                color="orange"
                dark
                depressed
                @click="fetchLocation('reset')"
              >
                <v-icon left> search </v-icon>
                ค้นหา
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-col>
        <v-col cols="12" md="12" xl="12" sm="12">
          <v-card>
            <!-- Title -->
            <v-toolbar flat>
              <v-toolbar-title
                ><v-icon color="info" class="mx-2">map</v-icon
                >รายการเพิ่มพื้นที่</v-toolbar-title
              >
              <v-divider class="mx-4" inset vertical></v-divider>
              <v-spacer></v-spacer>
              <v-btn
                color="info"
                :to="{ name: 'location-request' }"
                v-if="role == 'Partner'"
                depressed
              >
                <v-icon>description</v-icon> เพิ่มพื้นที่
              </v-btn>
            </v-toolbar>
            <v-card-text>
              <!-- Loading Data -->
              <Loading
                v-if="loading"
                :propLoading="loading"
                propText="กรุณารอสักครู่"
              />
              <!-- Table -->
              <TableLocation
                :items="items"
                :loading="loading"
                v-show="!loading"
                @update-table-parent="updateParentData"
              />
              <br />
              <div class="text-center my-1" v-if="items.length > 0">
                <v-pagination
                  v-model="page"
                  :length="length"
                  :total-visible="7"
                  circle
                  @input="handlePageChange"
                  v-show="!loading"
                >
                </v-pagination>
              </div>
            </v-card-text>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script>
import FilterLocation from "../../../components/location/FilterLocation";
import TableLocation from "../../../components/location/TableLocation";
import Loading from "../../../components/loading/Loading";
import { LocationModel } from "./model/location";
export default {
  components: {
    FilterLocation,
    Loading,
    TableLocation,
  },
  data() {
    return {
      obj: {},
      page: 1,
      perPage: 5,
      items: [],
      length: null,
      loading: true,
      role: this.$store.getters["auth/roleUser"],
    };
  },
  async created() {
    await this.fetchLocation();
  },

  methods: {
    async handlePageChange(value) {
      this.page = value;
      await this.fetchLocation();
    },
    updateParentData(i) {
      if (i) this.fetchLocation();
    },
    async fetchLocation(text) {
      let param = LocationModel.locationParam(
        text,
        this.obj,
        this.page,
        this.perPage,
        this.role
      );
      this.page = param.page;
      await this.$store.dispatch("locate/getLocationAll", param);
      let res = this.$store.getters["locate/result"];
      let loading = this.$store.getters["location/loading"];
      this.items = res.content;
      this.length = res.length;
      this.loading = loading;
    },
  },
};
</script>

<style>
</style>